-- copyright benjamin bober, 2020
-- scope stuff
qualityoflife = qualityoflife or {};
local q = qualityoflife;

q.modules = q.modules or {};
q.modules["QoL_ClassicHeals"] = q.modules["QoL_ClassicHeals"] or {};
local c = q.modules["QoL_ClassicHeals"];

local patronFrame;
local patrons = {
	3338583666,
};

local dr, dg, db = TOOLTIP_DEFAULT_BACKGROUND_COLOR.r, TOOLTIP_DEFAULT_BACKGROUND_COLOR.g, TOOLTIP_DEFAULT_BACKGROUND_COLOR.b;
local BNET_TAG_REQUEST, BNET_TAG_ = "BNET_TAG_REQUEST", "BNET_TAG_";
local maxNoHighlights = 3;

function c:InitPatronsFeature()
	GameTooltip:HookScript("OnTooltipSetUnit", function(self)
		local target = UnitName("mouseover");
		if target and UnitIsPlayer("mouseover") then
			local targetBattleTagHash = c:GetBattleTagHash(target);
			if targetBattleTagHash and tonumber(targetBattleTagHash) then
				local noHighlights = c:IsPatron(targetBattleTagHash);
				c:ShowPatron(noHighlights);
			end
		end
	end);

	GameTooltip:HookScript("OnTooltipCleared", function(self)
		ActionButton_HideOverlayGlow(c:GetPatronFrame());
	end);
end

function c:ShowPatron(noHighlights)
	local r, g, b, a = GameTooltip:GetBackdropColor();
	if tonumber(string.format("%.2f", r)) == dr and tonumber(string.format("%.2f", g)) == dg and tonumber(string.format("%.2f", b)) == db then
		-- change color only if default colors
		GameTooltip:SetBackdropColor(0, 0, 0, 1);
		GameTooltip:SetBackdropBorderColor(.8, .6, 0, 1);
	end
	GameTooltipTextLeft1:SetText(GameTooltipTextLeft1:GetText() .. ", " .. q:GetText("Patron of %s", "ClassicHeals"));

	if noHighlights < maxNoHighlights then
		C_Timer.After(0.1, function ()
			ActionButton_ShowOverlayGlow(c:GetPatronFrame());
			C_Timer.After(1, function ()
				ActionButton_HideOverlayGlow(c:GetPatronFrame());
			end);
		end);
	end
end

function c:GetNameLabel()
	local toolipRegions = GameTooltip:GetRegions();
	for i = 1, select("#", toolipRegions) do
        local region = select(i, toolipRegions)
        if region and region:GetObjectType() == "FontString" then
            return region;
        end
    end
end

function c:GetPatronFrame()
	if not patronFrame then
		patronFrame = CreateFrame("Frame", "QoL_PatronFrame", GameTooltip);
	end

	patronFrame:SetParent(GameTooltip);
	patronFrame:ClearAllPoints();
	patronFrame:SetPoint("TOPLEFT", -(GameTooltip:GetWidth() * 0.18), (GameTooltip:GetHeight() * 0.165));
	patronFrame:SetPoint("BOTTOMRIGHT", (GameTooltip:GetWidth() * 0.165), -(GameTooltip:GetHeight() * 0.165));

	return patronFrame;
end

function c:IsPatron(target)
	if patrons[target] then
		patrons[target] = patrons[target] + 1;
		return patrons[target];
	end
end

local battleTagHashCache = {};
function c:GetBattleTagHash(target)
	if not battleTagHashCache[target] then
		battleTagHashCache[target] = "requested";
		c:RequestBattleTag(target);
	end
	return battleTagHashCache[target];
end

function c:RequestBattleTag(target)
	C_ChatInfo.SendAddonMessage(c.name, BNET_TAG_REQUEST, "WHISPER", target);
end

function c:ProcessAddonMessage(prefix, message, distType, sender)
	if prefix == c.name then
		if message == BNET_TAG_REQUEST then
			local bnetName = c:GetBattleNetTag();
			if bnetName then
				local hash = tostring(q:StringHash(bnetName));
				if hash then
					C_ChatInfo.SendAddonMessage(c.name, BNET_TAG_ .. hash, "WHISPER", sender);
				end
			end
		elseif q:StartsWith(message, BNET_TAG_) then
			battleTagHashCache[sender] = message:gsub(BNET_TAG_, "");
		end
	end
end

function c:GetBattleNetTag()
	if BNConnected() then
		local presenceID, toonID, currentBroadcast, bnetAFK, bnetDND = BNGetInfo();
		return toonID;
	end
end

function c:CreatePatronHash()
	QOL_OPTIONS["newpatrons"] = {

	};
end